#ifndef WTRUNTIME_SYMTAB3_H
#define WTRUNTIME_SYMTAB3_H

#include "config.h"
#include "wtruntime.h"

struct wtr_symtab3;
struct wtr_sym;
struct wtr_vm;
struct wtr_program;

struct wtr_symtab3* wtr_symtab3_create(struct wtr_vm* const vm,
	struct wtr_program* const prog, wt_uint32_t typecnt);

wt_error wtr_symtab3_add_type(struct wtr_symtab3* const symtab,
	struct wtr_vm* const vm, struct wtr_sym* const sym,
	wt_uint32_t type_index);

wt_error wtr_symtab3_add_symbol(struct wtr_symtab3* const symtab,
	struct wtr_vm* const vm, struct wtr_sym* const sym,
	size_t* const out_index);

struct wtr_sym* wtr_symtab3_get_symbol(struct wtr_symtab3* const symtab,
	wt_uint32_t sym_index);

wt_error wtr_symtab3_resolve_undef(struct wtr_symtab3* const symtab,
	struct wtr_vm* const vm);

#endif /* WTRUNTIME_SYMTAB3_H */
