#ifndef WTRUNTIME_SYM3_H
#define WTRUNTIME_SYM3_H

#include "config.h"
#include "wtruntime.h"
#include "../welltype/sym.h"
#include "../welltype/wtb3.h"

struct wtr_vm;
struct wtr_sym;
struct wtr_lreader;
struct wtr_symtab;

/* Parse WTB3 symbol and create a runtime symbol from it. */
wt_error wtr_sym3_parse(struct wtr_vm* const vm,
	struct wtr_lreader* const lr, struct wtr_symtab* const symtab,
	struct wtr_sym** const p_sym, const wt_uint32_t shoffs,
	struct wtb3_sym* const symhdr, const enum wtr_symbind symbind);

#endif /* WTRUNTIME_SYM3_H */
